"use strict";
/*
  start: string = 'top 80%', // enter and leaveback
  end: string = 'top bottom', // leave and enterback
*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.GGScrollTrigger = void 0;
// TODO: Add more types
var GGScrollTrigger = /** @class */ (function () {
    function GGScrollTrigger(scrollTrigger, options) {
        if (options === void 0) { options = { markers: false }; }
        this.scrollTrigger = scrollTrigger;
        this.options = options;
    }
    GGScrollTrigger.prototype.setOptions = function (trigger, _a, type) {
        var animation = _a.animation, enter = _a.enter, enterBack = _a.enterBack, leave = _a.leave, leaveBack = _a.leaveBack, _b = _a.start, start = _b === void 0 ? 'top 80%' : _b, _c = _a.end, end = _c === void 0 ? 'top bottom' : _c, _d = _a.scrub, scrub = _d === void 0 ? false : _d;
        if (type === void 0) { type = 'default'; }
        return {
            trigger: trigger,
            animation: animation,
            start: type === 'return' ? 'top 100%' : start,
            end: end,
            markers: this.options.markers ? { startColor: 'red', endColor: 'green', fontSize: '18px', fontWeight: 'bold', indent: 20 } : false,
            scrub: scrub,
            onEnter: function () { return enter && enter(); },
            onLeaveBack: function () { return leaveBack && leaveBack(); },
            onLeave: function () { return leave && leave(); },
            onEnterBack: function () { return enterBack && enterBack(); },
        };
    };
    GGScrollTrigger.prototype.create = function (trigger, animation, _a) {
        var _b = _a === void 0 ? null : _a, _c = _b.targets, targets = _c === void 0 ? [] : _c, _d = _b.removeClasses, removeClasses = _d === void 0 ? false : _d, _e = _b.hasScrub, hasScrub = _e === void 0 ? false : _e;
        this.scrollTrigger.create(this.setOptions(trigger, {
            enter: function () { animation.play(); },
            scrub: hasScrub
        }));
        this.scrollTrigger.create(this.setOptions(trigger, {
            leaveBack: function () {
                animation.progress(0).pause();
                // TODO: Add class support to this later
                // if (removeClasses && targets !== undefined) {
                //   Array.prototype.forEach.call(targets, item => {
                //     if (item) {
                //       if (item.classList.contains('text-reveal--ltt')) {
                //         item.classList.remove(this.classes.reveal.ltt)
                //       }
                //       else {
                //         item.classList.remove(this.classes.reveal.ltr)
                //       }
                //     }
                //   })
                // }
            },
        }, 'return'));
    };
    return GGScrollTrigger;
}());
exports.GGScrollTrigger = GGScrollTrigger;
//# sourceMappingURL=index.js.map